<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: google_my_maps.php
| Author: Martin Pearman
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/header.php";
require_once INCLUDES."comments_include.php";
require_once INCLUDES."ratings_include.php";
require_once INFUSIONS."google_my_maps/infusion_db.php";
// Check if locale file is available matching the current site locale setting.
if (file_exists(LOCALE.LOCALESET."google_my_maps.php")) {
	// Load the locale file matching the current site locale setting.
	include LOCALE.LOCALESET."google_my_maps.php";
} else {
	// Load the infusion's default locale file.
	include LOCALE."English/google_my_maps.php";
}

if(!defined("IN_FUSION")){
	die("Access Denied");
}

if (!isset($_GET['map_id']) || !isnum($_GET['map_id'])){
	//	redirect("../../index.php");
	die("Debug");
}

$server_name=$_SERVER['SERVER_NAME'];
$result=dbquery("SELECT api_key FROM ".MY_MAPS_APIKEYS." WHERE server_name='$server_name' LIMIT 1;");
if(dbrows($result)==0){
	redirect("../../index.php");
} else {
	$data=dbarray($result);
	$api_key=$data['api_key'];
}

$result = dbquery("SELECT * FROM ".MY_MAPS_KML." WHERE id='".$_GET['map_id']."'");
if (dbrows($result)) {
	$data = dbarray($result);
	if (checkgroup($data['access_control'])){
		$map_height=$data['map_height'].'px';
		$map_sidebar=$data['map_sidebar'];
		$map_title=$data['map_title'];
		$enable_cluster_marker=$data['enable_cluster_marker']==1?'true':'false';
		$enable_default_ui=$data['enable_default_ui']==1?'true':'false';
		$enable_directions=$data['enable_directions']==1?'true':'false';
		$enable_overview_map=$data['enable_overview_map']==1?'true':'false';
		
		echo <<<CODE
		<script type="text/javascript" src="http://maps.google.com/maps?file=api&amp;v=2&amp;key=$api_key&amp;sensor=false"></script>
		<script type="text/javascript" src="scripts/egeoxml.js"></script>
		<script type="text/javascript" src="scripts/ClusterMarker.js"></script>
		<script type="text/javascript" src="scripts/google_my_maps.js"></script>
		<script type="text/javascript">
		var INIT_OBJ={directions:$enable_directions, enableClusterMarker:$enable_cluster_marker, enableDefaultUI:$enable_default_ui, enableOverviewMap:$enable_overview_map, kmlHref:'{$data['kml_href']}', mapType:'{$data['map_type']}', sidebar:'$map_sidebar'};
		</script>
CODE;
		
		add_to_title($locale['global_200'].$map_title);
		opentable($map_title);
		$mapHtml=<<<CODE
		<div id="googleMyMapsMapCtn" style="width:640px; height:$map_height; overflow:hidden">
			<noscript>
				<h4>Javascript is either disabled or not supported by your browser.<br />
				Please enable javascript in your browser settings and <a href="javascript:location.reload(true)">refresh</a> this page, or visit <a href="http://maps.google.co.uk/support/">Google Maps Help</a> for more information.</h4>
			</noscript>
		</div>
CODE;
		$sidebarHtml=<<<CODE
		<div id="googleMyMapsSidebarCtn" style="width:196px; height:$map_height; overflow:auto"></div>
CODE;
		$tableHtml=<<<CODE
		<table style="border-collapse:collapse" cellpadding="0" cellspacing="0" id="googleMyMapsCtn">
			<tr>
CODE;
		switch($map_sidebar){
			case 'left':
				$tableHtml.=<<<CODE
				<td>$sidebarHtml</td>
				<td>$mapHtml</td>
CODE;
				break;
			case 'right':
				$tableHtml.=<<<CODE
				<td>$mapHtml</td>
				<td><img src="http://maps.gstatic.com/intl/en_ALL/mapfiles/transparent.png" width="1" height="1" alt="" /></td>
				<td>$sidebarHtml</td>
CODE;
				break;
			case 'none':
				$tableHtml.=<<<CODE
				<td>$mapHtml</td>
CODE;
				break;
		}
		$tableHtml.=<<<CODE
		</tr>
		</table>
CODE;
		echo $tableHtml;
		closetable();
	} else {
		add_to_title($locale['global_200'].$map_title);
		opentable($map_title);
		echo <<<CODE
		<div style="text-align:center"><br />{$locale['400']}<br /></div>
CODE;
		closetable();
	}
} else {
	add_to_title($locale['global_200'].$locale['401']);
	opentable($locale['401']);
	echo <<<CODE
	<div style="text-align:center"><br />{$locale['402']}<br /></div>
CODE;
	closetable();
}
if (dbrows($result) && checkgroup($data['access_control'])) {
	if ($data['allow_comments']) { showcomments("GM", MY_MAPS_KML, "id", $_GET['map_id'],FUSION_SELF."?map_id=".$_GET['map_id']); }
	if ($data['allow_ratings']) { showratings("G", $_GET['map_id'], FUSION_SELF."?map_id=".$_GET['map_id']); }
}

require_once THEMES."templates/footer.php";
?>
