<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: google_my_maps_admin.php
| Author: Martin Pearman
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header_mce.php";
require_once INFUSIONS."google_my_maps/infusion_db.php";
//	include LOCALE.LOCALESET."admin/google_my_maps.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(LOCALE.LOCALESET."admin/google_my_maps.php")) {
	// Load the locale file matching the current site locale setting.
	include LOCALE.LOCALESET."admin/google_my_maps.php";
} else {
	// Load the infusion's default locale file.
	include LOCALE."English/admin/google_my_maps.php";
}

if (!checkrights("GMMA") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../index.php"); }

if (isset($_GET['status']) && !isset($message)) {
	if ($_GET['status'] == "sn") {
		$message = $locale['410']."<br />\n".$locale['412']."\n<a href='".BASEDIR."infusions/google_my_maps/google_my_maps.php?map_id=".intval($_GET['pid'])."'>infusions/google_my_maps/google_my_maps.php?map_id=".intval($_GET['pid'])."</a>\n";
	} elseif ($_GET['status'] == "su") {
		$message = $locale['411']."<br />\n".$locale['412']."\n<a href='".BASEDIR."infusions/google_my_maps/google_my_maps.php?map_id=".intval($_GET['pid'])."'>infusions/google_my_maps/google_my_maps.php?map_id=".intval($_GET['pid'])."</a>\n";
	} elseif ($_GET['status'] == "del") {
		$message = $locale['413'];
	} elseif ($_GET['status'] == "pw") {
		$message = $locale['global_182'];
	}
	if ($message) {	echo "<div class='admin-message'>".$message."</div>\n"; }
}

if (isset($_POST['save'])) {
	$kml_href = htmlspecialchars_decode(stripinput($_POST['kml_href']));
	$map_height=stripinput($_POST['map_height']);
	$map_sidebar=stripinput($_POST['map_sidebar']);
	$map_title = stripinput($_POST['map_title']);
	$map_type=stripinput($_POST['map_type']);
	$enable_cluster_marker=isset($_POST['enable_cluster_marker']) ? "1" : "0";
	$enable_default_ui=isset($_POST['enable_default_ui']) ? "1" : "0";
	$enable_directions=isset($_POST['enable_directions']) ? "1" : "0";
	$enable_overview_map=isset($_POST['enable_overview_map']) ? "1" : "0";
	$access_control = isnum($_POST['access_control']) ? $_POST['access_control'] : "0";
	$allow_comments = isset($_POST['map_comments']) ? "1" : "0";
	$allow_ratings = isset($_POST['map_ratings']) ? "1" : "0";
	$admin_password = isset($_POST['admin_password']) ? $_POST['admin_password'] : "";
	if ((isset($_COOKIE[COOKIE_PREFIX.'admin']) && md5($_COOKIE[COOKIE_PREFIX.'admin']) == $userdata['user_admin_password']) || md5(md5($admin_password)) == $userdata['user_admin_password']) {
		if (isset($_POST['map_id']) && isnum($_POST['map_id'])) {
			$query='UPDATE '.MY_MAPS_KML.' SET ';
			$query.=<<<QUERY
			kml_href='$kml_href',
			map_height='$map_height',
			map_sidebar='$map_sidebar',
			map_title='$map_title',
			map_type='$map_type',
			enable_cluster_marker=$enable_cluster_marker,
			enable_default_ui=$enable_default_ui,
			enable_directions=$enable_directions,
			enable_overview_map=$enable_overview_map,
			access_control=$access_control,
			allow_comments=$allow_comments,
			allow_ratings=$allow_ratings
			WHERE id='{$_POST['map_id']}';
QUERY;
			$result = dbquery($query);
		} else {
			$query='INSERT INTO '.MY_MAPS_KML.' (';
			$query.=<<<QUERY
			kml_href,
			map_height,
			map_sidebar,
			map_title,
			map_type,
			enable_cluster_marker,
			enable_default_ui,
			enable_directions,
			enable_overview_map,
			access_control,
			allow_comments,
			allow_ratings) VALUES (
			'$kml_href',
			'$map_height',
			'$map_sidebar',
			'$map_title',
			'$map_type',
			$enable_cluster_marker,
			$enable_default_ui,
			$enable_directions,
			$enable_overview_map,
			$access_control,
			$allow_comments,
			$allow_ratings
			);	
QUERY;
			$result=dbquery($query);
			$map_id = mysql_insert_id();
			if (isset($_POST['add_link'])) {
				$data = dbarray(dbquery("SELECT * FROM ".DB_SITE_LINKS." ORDER BY link_order DESC LIMIT 1"));
				$link_order = $data['link_order'] + 1;
				$result = dbquery("INSERT INTO ".DB_SITE_LINKS." (link_name, link_url, link_visibility, link_position, link_window, link_order) VALUES ('$map_title', 'infusions/google_my_maps/google_my_maps.php?map_id=$map_id', '$access_control', '1', '0', '$link_order')");
			}
		}
		if (!isset($_COOKIE[COOKIE_PREFIX.'admin']) && md5(md5($admin_password)) == $userdata['user_admin_password']) {
			setcookie(COOKIE_PREFIX."admin", md5($admin_password), time() + 3600, "/", "", "0");
		}
		if (isset($_POST['map_id']) && isnum($_POST['map_id'])) {
			redirect(FUSION_SELF.$aidlink."&status=su&pid=".$_POST['map_id'], true);
		} else {
			redirect(FUSION_SELF.$aidlink."&status=sn&pid=".$map_id, true);
		}
	} else {
		redirect(FUSION_SELF.$aidlink."&status=pw");
	}
} else if (isset($_POST['delete']) && (isset($_POST['map_id']) && isnum($_POST['map_id']))) {
	$result = dbquery("DELETE FROM ".MY_MAPS_KML." WHERE map_id='".$_POST['map_id']."'");
	$result = dbquery("DELETE FROM ".DB_SITE_LINKS." WHERE link_url='infusions/google_my_maps/google_my_maps.php?map_id=".$_POST['map_id']."'");
	redirect(FUSION_SELF.$aidlink."&status=del");
} else {
	if (isset($_POST['preview'])) {
		$kml_href = htmlspecialchars_decode(stripinput($_POST['kml_href']));
		$map_height=stripinput($_POST['map_height']);
		$map_sidebar=stripinput($_POST['map_sidebar']);
		$map_title = stripinput($_POST['map_title']);
		$map_type=stripinput($_POST['map_type']);
		$enable_cluster_marker=isset($_POST['enable_cluster_marker']) ? "1" : "0";
		$enable_default_ui=isset($_POST['enable_default_ui']) ? "1" : "0";
		$enable_directions=isset($_POST['enable_directions']) ? "1" : "0";
		$enable_overview_map=isset($_POST['enable_overview_map']) ? "1" : "0";
		$access_control = $_POST['access_control'];
		$allow_comments = isset($_POST['map_comments']) ? " checked='checked'" : "";
		$allow_ratings = isset($_POST['map_ratings']) ? " checked='checked'" : "";
		$admin_password = isset($_POST['admin_password']) ? $_POST['admin_password'] : "";
		$addlink = isset($_POST['add_link']) ? " checked='checked'" : "";
		if ((isset($_COOKIE[COOKIE_PREFIX.'admin']) && md5($_COOKIE[COOKIE_PREFIX.'admin']) == $userdata['user_admin_password']) || md5(md5($admin_password)) == $userdata['user_admin_password']) {
			opentable($map_title);
			eval("?>".$kml_href."<?php ");
			closetable();
			if (!isset($_COOKIE[COOKIE_PREFIX.'admin']) && md5(md5($admin_password)) == $userdata['user_admin_password']) {
				setcookie(COOKIE_PREFIX."admin", md5($admin_password), time() + 3600, "/", "", "0");
			}
		} else {
			echo "<div class='admin-message'>".$locale['global_182']."</div>\n";
		}
		//	$kml_href = phpentities($kml_href);
	}
	$result = dbquery("SELECT * FROM ".MY_MAPS_KML." ORDER BY map_title");
	if (dbrows($result) != 0) {
		$editlist = ""; $sel = "";
		while ($data = dbarray($result)) {
			if (isset($_POST['map_id'])) { $sel = ($_POST['map_id'] == $data['id'] ? " selected='selected'" : ""); }
			$editlist .= "<option value='".$data['id']."'$sel>".$data['map_title']."</option>\n";
		}
		opentable($locale['402']);
		echo "<div style='text-align:center'>\n<form name='selectform' method='post' action='".FUSION_SELF.$aidlink."'>\n";
		echo "<select name='map_id' class='textbox' style='width:200px;'>\n".$editlist."</select>\n";
		echo "<input type='submit' name='edit' value='".$locale['420']."' class='button' />\n";
		echo "<input type='submit' name='delete' value='".$locale['421']."' onclick='return DeletePage();' class='button' />\n";
		echo "</form>\n</div>\n";
		closetable();
	}

	if (isset($_POST['edit']) && (isset($_POST['map_id']) && isnum($_POST['map_id']))) {
		$result = dbquery("SELECT * FROM ".MY_MAPS_KML." WHERE id='".$_POST['map_id']."'");
		if (dbrows($result)) {
			$data = dbarray($result);
			$kml_href = $data['kml_href'];
			$map_height=$data['map_height'];
			$map_sidebar=$data['map_sidebar'];
			$map_title = $data['map_title'];
			$map_type = $data['map_type'];
			$enable_cluster_marker = ($data['enable_cluster_marker'] == "1" ? " checked='checked'" : "");
			$enable_default_ui = ($data['enable_default_ui'] == "1" ? " checked='checked'" : "");
			$enable_directions = ($data['enable_directions'] == "1" ? " checked='checked'" : "");
			$enable_overview_map = ($data['enable_overview_map'] == "1" ? " checked='checked'" : "");
			$access_control = $data['access_control'];
			$allow_comments = ($data['allow_comments'] == "1" ? " checked='checked'" : "");
			$allow_ratings = ($data['allow_ratings'] == "1" ? " checked='checked'" : "");
			$admin_password = "";
			$addlink = "";
		} else {
			redirect(FUSION_SELF.$aidlink);
		}
	}
	if (isset($_POST['map_id']) && isnum($_POST['map_id'])) {
		opentable($locale['401']);
	} else {
		if (!isset($_POST['preview'])) {
			//	set defaults for new submissions
			$kml_href = '';
			$map_height='600';
			$map_sidebar='left';
			$map_title = '';
			$map_type='normal';
			$enable_cluster_marker=" checked='checked'";
			$enable_default_ui=" checked='checked'";
			$enable_directions='';
			$enable_overview_map='';
			$access_control = '';
			$allow_comments = " checked='checked'";
			$allow_ratings = " checked='checked'";
			$admin_password = '';
			$addlink = "";
		}
		opentable($locale['400']);
	}
	$user_groups = getusergroups(); $access_opts = ""; $sel = "";
	while(list($key, $user_group) = each($user_groups)){
		$sel = ($access_control == $user_group['0'] ? " selected='selected'" : "");
		$access_opts .= "<option value='".$user_group['0']."'$sel>".$user_group['1']."</option>\n";
	}
	echo "<form name='inputform' method='post' action='".FUSION_SELF.$aidlink."' onsubmit='return ValidateForm(this);'>\n";
	echo "<table cellpadding='0' cellspacing='0' class='center'>\n<tr>\n";
	
	echo "<td width='100' class='tbl'>".$locale['422']."</td>\n";
	echo "<td width='80%' class='tbl'><input type='text' name='map_title' value='".$map_title."' class='textbox' style='width:250px;' />\n";
	
	echo "&nbsp;".$locale['423']."<select name='access_control' class='textbox' style='width:150px;'>\n".$access_opts."</select></td>\n";
	echo "</tr>\n<tr>\n";
	
	echo "<td valign='top' width='100' class='tbl'>".$locale['424']."</td>\n";
	echo "<td width='80%' class='tbl'><textarea name='kml_href' cols='95' rows='2' class='textbox' style='width:98%'>".$kml_href."</textarea></td>\n";
	echo "</tr>\n<tr>\n";
	
	$map_type_values=array('normal', 'satellite', 'hybrid', 'terrain');
	$map_type_opts='';
	foreach($map_type_values as $type){
		$map_type_opts.="<option value='$type'";
		if($type==$map_type){
			$map_type_opts.=" selected='selected'";
		}
		$map_type_opts.=">".ucfirst($type)."</option>";
	}
	echo "<td valign='top' width='100' class='tbl'>".$locale['440'].":</td>\n";
	echo "<td width='80%' class='tbl'><select name='map_type' class='textbox' style='width:150px'>".$map_type_opts."</select></td>";
	echo "</tr>\n<tr>\n";
	
	$sidebar_values=array('none', 'left', 'right');
	$sidebar_opts='';
	foreach($sidebar_values as $value){
		$sidebar_opts.="<option value='$value'";
		if($map_sidebar==$value){
			$sidebar_opts.=" selected='selected'";
		}
		$sidebar_opts.=">".ucfirst($value)."</option>";
	}
	echo "<td valign='top' width='100' class='tbl'>".$locale['434'].":</td>\n";
	echo "<td width='80%' class='tbl'><select name='map_sidebar' class='textbox' style='width:150px'>".$sidebar_opts."</select></td>";
	echo "</tr>\n<tr>\n";
	
	$map_height_values=array('480', '600', '768', '900', '1024', '1080', '1280');
	$map_height_opts='';
	foreach($map_height_values as $height){
		$map_height_opts.="<option value='$height'";
		if($height==$map_height){
			$map_height_opts.=" selected='selected'";
		}
		$map_height_opts.=">$height</option>";
	}
	echo "<td valign='top' width='100' class='tbl'>".$locale['433'].":</td>\n";
	echo "<td width='80%' class='tbl'><select name='map_height' class='textbox' style='width:150px'>".$map_height_opts."</select></td>";
	echo "</tr>\n<tr>\n";

	echo "<td class='tbl'></td><td class='tbl'>\n";
	echo "<label><input type='checkbox' name='enable_cluster_marker' value='1'".$enable_cluster_marker." /> ".$locale['438']."</label>\n";
	echo "</td>\n</tr>\n<tr>\n";
	
	echo "<td class='tbl'></td><td class='tbl'>\n";
	echo "<label><input type='checkbox' name='enable_default_ui' value='1'".$enable_default_ui." /> ".$locale['439']."</label>\n";
	echo "</td>\n</tr>\n<tr>\n";
	
	echo "<td class='tbl'></td><td class='tbl'>\n";
	echo "<label><input type='checkbox' name='enable_directions' value='1'".$enable_directions." /> ".$locale['431']."</label>\n";
	echo "</td>\n</tr>\n<tr>\n";
	
	echo "<td class='tbl'></td><td class='tbl'>\n";
	echo "<label><input type='checkbox' name='enable_overview_map' value='1'".$enable_overview_map." /> ".$locale['432']."</label>\n";
	echo "</td>\n</tr>\n<tr>\n";
	
	if ((!isset($_COOKIE[COOKIE_PREFIX.'admin']) || md5($_COOKIE[COOKIE_PREFIX.'admin']) != $userdata['user_admin_password']) && (!isset($admin_password) || md5(md5($admin_password)) != $userdata['user_admin_password'])) {
		echo "<td class='tbl'>".$locale['425']."</td>\n";
		echo "<td class='tbl'><input type='password' name='admin_password' value='".$admin_password."' class='textbox' style='width:150px;' /></td>\n";
		echo "</tr>\n<tr>\n";
	}
	
	echo "<td class='tbl'></td><td class='tbl'>\n";
	if (!isset($_POST['map_id']) || !isnum($_POST['map_id'])) {
		echo "<label><input type='checkbox' name='add_link' value='1'".$addlink." />  ".$locale['426']."</label><br />\n";
	}
	echo "<label><input type='checkbox' name='map_comments' value='1'".$allow_comments." /> ".$locale['427']."</label><br />\n";
	echo "<label><input type='checkbox' name='map_ratings' value='1'".$allow_ratings." /> ".$locale['428']."</label>\n";
	echo "</td>\n</tr>\n<tr>\n";
	echo "<td align='center' colspan='2' class='tbl'>\n";
	if (isset($_POST['map_id']) && isnum($_POST['map_id'])) {
		echo "<input type='hidden' name='map_id' value='".$_POST['map_id']."' />\n";
	}
	//	echo "<input type='submit' name='preview' value='".$locale['429']."' class='button' />\n";
	echo "<input type='submit' name='save' value='".$locale['430']."' class='button' /></td>\n";
	echo "</tr>\n</table>\n</form>\n";
	closetable();
	
	echo <<<CODE
	<script type="text/javascript">
	function DeletePage(){
		return confirm('{$locale['450']}');
	}
	function ValidateForm(frm){
		var message=[];
		if(frm.map_title.value=='') {
			message.push('{$locale['451']}');
		}
		if(frm.kml_href.value==''){
			message.push('{$locale['457']}');
		} else {
			var exp=/^(([\w]+:)?\/\/)?(([\d\w]|%[a-fA-f\d]{2,2})+(:([\d\w]|%[a-fA-f\d]{2,2})+)?@)?([\d\w][-\d\w]{0,253}[\d\w]\.)+[\w]{2,4}(:[\d]+)?(\/([-+_~.\d\w]|%[a-fA-f\d]{2,2})*)*(\?(&?([-+_~.\d\w]|%[a-fA-f\d]{2,2})=?)*)?(#([-+_~.\d\w]|%[a-fA-f\d]{2,2})*)?$/;
			if(!exp.test(frm.kml_href.value)){
				message.push('{$locale['458']}');
			}
		}
		if(frm.admin_password.value=='') {
			message.push('{$locale['452']}');
		}
		if(message.length>0){
			message=message.join("\\n");
			alert(message);
			return false;
		} else {
			return true;
		}
	}
	</script>
CODE;
}

require_once THEMES."templates/footer.php";
?>