<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright  2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: infusion.php
| Author: Martin Pearman
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined('IN_FUSION')) { die('Access Denied'); }

require_once INFUSIONS.'google_my_maps/infusion_db.php';

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS.'google_my_maps/locale/'.$settings['locale'].'.php')) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS.'google_my_maps/locale/'.$settings['locale'].'.php';
} else {
	// Load the infusion's default locale file.
	include INFUSIONS.'google_my_maps/locale/English.php';
}

// Infusion general information
$inf_title=$locale['googlemymaps_title'];
$inf_description=$locale['googlemymaps_desc'];
$inf_version='1.0';
$inf_developer='Martin Pearman';
$inf_email='developer@martinpearman.co.uk';
$inf_weburl='http://developer.martinpearman.co.uk/';

$inf_folder='google_my_maps';

//	WHEN INFUSED:
//	create the infusion tables
$inf_newtable[1]=MY_MAPS_KML."(
  id mediumint(8) NOT NULL AUTO_INCREMENT,
  kml_href varchar(255) NOT NULL,
  map_height enum('480','600','768','900','1024','1080','1280') NOT NULL DEFAULT '600',
  map_sidebar enum('left','right','none') NOT NULL DEFAULT 'left',
  map_title varchar(200) NOT NULL,
  map_type enum('normal','satellite','hybrid','terrain') NOT NULL DEFAULT 'normal',
  enable_cluster_marker tinyint(1) unsigned NOT NULL DEFAULT '1',
  enable_default_ui tinyint(1) unsigned NOT NULL DEFAULT '1',
  enable_directions tinyint(1) unsigned NOT NULL DEFAULT '0',
  enable_overview_map tinyint(1) unsigned NOT NULL DEFAULT '0',
  access_control tinyint(3) unsigned NOT NULL DEFAULT '0',
  allow_comments tinyint(1) unsigned NOT NULL DEFAULT '1',
  allow_ratings tinyint(1) unsigned NOT NULL DEFAULT '1',
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;";

$inf_newtable[2]=MY_MAPS_APIKEYS."(
  id mediumint(8) NOT NULL AUTO_INCREMENT,
  server_name varchar(255) CHARACTER SET utf8 NOT NULL,
  api_key varchar(90) CHARACTER SET utf8 NOT NULL,
  PRIMARY KEY (id)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;";


/*	access rights:
	0	Public
	101	Member
	102	Administrator
	103	Super Administrator
*/
//	and create default row(s) and links
$inf_insertdbrow[1]=MY_MAPS_KML.'(';
$inf_insertdbrow[1].=<<<QUERY
	kml_href,
	map_height,
	map_sidebar,
	map_type,
	map_title,
	enable_cluster_marker,
	enable_default_ui,
	enable_directions,
	enable_overview_map,
	access_control,
	allow_comments,
	allow_ratings) VALUES (
	'http://maps.google.co.uk/maps/ms?ie=UTF8&hl=en&vps=1&jsv=196c&oe=UTF8&msa=0&msid=111791480420984706339.00047820042c4c87e721b&output=kml',
	'600',
	'left',
	'normal',
	'{$locale['googlemymaps_link1']}',
	1,
	1,
	0,
	1,
	0,
	0,
	0);
QUERY;
$inf_sitelink[1]=array('title'=>$locale['googlemymaps_link1'], 'url'=>'google_my_maps.php?map_id=1', 'visibility'=>'0');

$inf_insertdbrow[2]=MY_MAPS_KML.'(';
$inf_insertdbrow[2].=<<<QUERY
	kml_href,
	map_height,
	map_sidebar,
	map_type,
	map_title,
	enable_cluster_marker,
	enable_default_ui,
	enable_directions,
	enable_overview_map,
	access_control,
	allow_comments,
	allow_ratings) VALUES (
	'http://www.geograph.org.uk/feed/results/9817859/1.kml',
	'768',
	'right',
	'hybrid',
	'{$locale['googlemymaps_link2']}',
	1,
	1,
	1,
	1,
	0,
	1,
	1);
QUERY;
$inf_sitelink[2]=array('title'=>$locale['googlemymaps_link2'], 'url'=>'google_my_maps.php?map_id=2', 'visibility'=>'0');

$inf_insertdbrow[3]=MY_MAPS_KML.'(';
$inf_insertdbrow[3].=<<<QUERY
	kml_href,
	map_height,
	map_sidebar,
	map_type,
	map_title,
	enable_cluster_marker,
	enable_default_ui,
	enable_directions,
	enable_overview_map,
	access_control,
	allow_comments,
	allow_ratings) VALUES (
	'http://maps.google.co.uk/maps/ms?ie=UTF8&hl=en&vps=1&jsv=196c&msa=0&output=kml&msid=111791480420984706339.00047bb1112f878e56292',
	'480',
	'none',
	'terrain',
	'{$locale['googlemymaps_link3']}',
	0,
	1,
	0,
	1,
	0,
	0,
	0);
QUERY;
$inf_sitelink[3]=array('title'=>$locale['googlemymaps_link3'], 'url'=>'google_my_maps.php?map_id=3', 'visibility'=>'0');

$inf_adminpanel[1]=array('title'=>$locale['googlemymaps_admin1'], 'image'=>'map_globe.jpg', 'panel'=>'google_my_maps_admin_kml.php', 'rights'=>'GMMA');
$inf_adminpanel[2]=array('title'=>$locale['googlemymaps_admin2'], 'image'=>'map_globe.jpg', 'panel'=>'google_my_maps_admin_keys.php', 'rights'=>'GMMB');

//	and create an api key for localhost and martinspc.homeip.net
$inf_insertdbrow[4]=MY_MAPS_APIKEYS."(server_name, api_key) VALUES ('localhost', '12345678901234567890123456789012345678901234567890123456789012345678901234567890123456');";

//	WHEN DEFUSED:
//	delete the infusion table when defused
$inf_droptable[1]=MY_MAPS_KML;
$inf_droptable[2]=MY_MAPS_APIKEYS;

//	and remove comments where comment_type is GM, and ratings where rating_type is G
$inf_deldbrow[1]=DB_PREFIX."comments WHERE comment_type='GM';";
$inf_deldbrow[2]=DB_PREFIX."ratings WHERE rating_type='G';";

/*
$inf_altertable[1]=MY_MAPS_KML.' ADD etc';
*/

?>
