/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2008 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: google_my_maps.js
| Author: Martin Pearman
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

function HtmlControl(_1,_2){this.html=_1;this.isVisible=true;this.isPrintable=false;this.isSelectable=false;if(_2){this.isVisible=(_2.visible===false)?false:true;this.isPrintable=(_2.printable===true)?true:false;this.isSelectable=(_2.selectable===true)?true:false;}}HtmlControl.prototype=new GControl();HtmlControl.prototype.initialize=function(_3){this.div=document.createElement("div");this.div.innerHTML=this.html;this.setVisible(this.isVisible);_3.getContainer().appendChild(this.div);return this.div;};HtmlControl.prototype.getDefaultPosition=function(){return new GControlPosition(G_ANCHOR_TOP_LEFT,new GSize(7,7));};HtmlControl.prototype.selectable=function(){return this.isSelectable;};HtmlControl.prototype.printable=function(){return this.isPrintable;};HtmlControl.prototype.setVisible=function(_4){this.div.style.display=_4?"":"none";this.isVisible=_4;};HtmlControl.prototype.visible=function(){return this.isVisible;};

function GoogleMyMaps($options){
	function getScrollbarWidth() {
		var $src, $inn, $wNoScroll=0, $wNoScroll=0;
		$src=document.createElement('div');
		$src.style.position='absolute';
		$src.style.top='-1000px';
		$src.style.left='-1000px';
		$src.style.width='100px';
		$src.style.height='50px';
		$src.style.overflow='hidden';
		$inn=document.createElement('div');
		$inn.style.width='100%';
		$inn.style.height='200px';
		$src.appendChild($inn);
		document.body.appendChild($src);
		$wNoScroll=$inn.offsetWidth;
		$src.style.overflow='auto';
		$wNoScroll=$inn.offsetWidth;
		document.body.removeChild(document.body.lastChild);
		return ($wNoScroll-$wNoScroll);
	}
	var $this=this, $map;
	if(GBrowserIsCompatible()){
		var $mapCtn=document.getElementById($options.mapCtn);
		$map=new GMap2($mapCtn);
		var $mapTypes={normal:G_NORMAL_MAP, satellite:G_SATELLITE_MAP, hybrid:G_HYBRID_MAP, terrain:G_PHYSICAL_MAP};
		$map.setCenter(new GLatLng(0, 0), 0, $mapTypes[$options.mapType]);
		if($options.enableDefaultUI===true){
			$map.setUIToDefault();
		}
		if($options.enableOverviewMap===true){
			$map.addControl(new GOverviewMapControl());
		}
		$this.map=$map;
		$this.mapCtn=$mapCtn;
		
		$this.loadingMessage=new HtmlControl('<img src="images/map_loading.gif" width="220" height="19" alt="Map loading..." />');
		$this.displayLoadingMessage(true);
		
		if(typeof($options.sidebarid)!=='undefined'){
			$this.sidebarEnabled=true;
			$this.sidebar=document.getElementById($options.sidebarid)
		}
		$this.exml=new EGeoXml('googleMyMaps.exml', $map, null, $options);
		$this.clusterMarker=new ClusterMarker($map);
		$this.clusterMarker.clusteringEnabled=$options.enableClusterMarker;
		$this.displayLoadingMessage(false);
		$this.scrollbarWidth=getScrollbarWidth();
		$this.fitMapToParent();
		GEvent.addDomListener(window, 'resize', function(){
			$this.fitMapToParent();
		});
	} else {
		if(confirm('Sorry, your browser is not compatible with Google Maps.\nFor more information please click OK to visit:\nGoogle Maps Help\nhttp://maps.google.co.uk/support.')){
			window.location='http://maps.google.co.uk/support/';
		}
	}
}

GoogleMyMaps.prototype.displayLoadingMessage=function($bool){
	var $this=this, $map=$this.map;
	if($bool){
		var m=$map.getSize(), x=(m.width/2)-110, y=(m.height/2)-9;
		$map.addControl($this.loadingMessage, new GControlPosition(G_ANCHOR_TOP_LEFT, new GSize(x, y)));
	} else {
		$map.removeControl($this.loadingMessage);
	}
};

GoogleMyMaps.prototype.fitMapToParent=function(){
	var $this=this, $parentCtn=document.getElementById('googleMyMapsCtn').parentNode, $parentWidth=$parentCtn.clientWidth, $sidebarWidth, $map=$this.map, $mapCenter=$map.getCenter();
	//	GLog.write($parentCtn.clientWidth);
	if($this.sidebarEnabled){
		$sidebarWidth=$this.sidebar.offsetWidth+$this.scrollbarWidth;
	} else {
		$sidebarWidth=0;
	}
	$this.mapCtn.style.width=($parentWidth-$sidebarWidth-7)+'px';
	$map.checkResize();
	$map.setCenter($mapCenter);
	//	GLog.write($this.mapCtn.style.width);
};

GoogleMyMaps.prototype.getKML=function($href){
	var $this=this, $map=$this.map, $exml=$this.exml, $clusterMarker=$this.clusterMarker;
	$this.displayLoadingMessage(true);
	$exml.listener=GEvent.addListener($exml, 'parsed', function(){
		GEvent.removeListener($exml.listener);
		$map.savePosition();
		$clusterMarker.addMarkers($exml.gmarkers, true);
		$clusterMarker.refresh();
		$this.displayLoadingMessage(false);
	});
	$href='scripts/get_remote_kml.php?map_href='+encodeURIComponent($href);
	$exml.urls=[$href];
	$exml.parse();
};

GoogleMyMaps.prototype.markerClickHandler=function($marker, $html, $iwopts, $exml){
	var $clusterMarker=$marker._ClusterMarker_.instance;
	
	//	force an update of doNotCluster
	$exml.map.closeInfoWindow();
	if($marker._ClusterMarker_.isOverlaid){
		//	marker is visible
		//	var $width=$exml.map.getSize().width;
		//	$exml.iwwidth=($width/2)<328?328:$width/2;
		$marker.openInfoWindow($html, $iwopts);
		$clusterMarker.setDoNotCluster($marker, true);
	} else if(!$marker._ClusterMarker_.isActive){
		//	marker is not overlaid to the map, center on the marker and trigger a click on it
		$exml.map.setCenter($marker.getLatLng());
		//	$clusterMarker.refresh();
		GEvent.trigger($marker, 'click');
	} else {
		//	marker is clustered
		$clusterMarker.setDoNotCluster($marker, true);
		$clusterMarker.refresh();
		GEvent.trigger($marker, 'click');
		/*	var $unclusteredZoom=$clusterMarker.getMinUnclusterLevel($marker), $maxZoom=$exml.map.getCurrentMapType().getMaximumResolution();
		if($unclusteredZoom>=$maxZoom){
			//	marker will not uncluster even at the current map type's max zoom level
			$exml.map.setZoom($maxZoom);
		} else {
			//	marker will be unclustered at $unclusteredZoom zoom level
			$exml.map.setZoom($unclusteredZoom);
		}	*/
	}
};

var googleMyMaps;

function myOnload(){
	//	parse the INIT_OBJECT and set preferences
	var $options=INIT_OBJ;
	INIT_OBJ=null;
	$options.mapCtn='googleMyMapsMapCtn';
	if($options.sidebar!=='none'){
		$options.sidebarid='googleMyMapsSidebarCtn';
		$options.sortbyname=true;
	}
	/*	See the EGeoXml documentation for more options:
		http://econym.org.uk/gmap/egeoxml.htm
	*/
	$options.noshadow=$options.noshadow || true;
	$options.iwwidth=$options.iwwidth || 296;
	googleMyMaps=new GoogleMyMaps($options);
	if($options.kmlHref){
		googleMyMaps.getKML($options.kmlHref);
	}
}

if(window.addEventListener){
	window.addEventListener('load', myOnload, false );
	window.addEventListener('unload', GUnload, false );
} else {
	window.attachEvent('onload', myOnload );
	window.attachEvent('onunload', GUnload );
}

var $node=document.createElement('link');
$node.type='text/css';
$node.rel='stylesheet';
$node.href='google_my_maps.css';
document.getElementsByTagName('head')[0].appendChild($node);
